<?php 

class schetmashCheckModel extends waModel
{
	protected $table = 'schetmash_check';

	const SERVICE_URL = 'https://online.schetmash.com/lk/api/v1';
	const SERVICE_PORT = 443;


	private function buildCheckQuery($data, $operation) {

		

		$config = wa('schetmash')->getConfig();		
     
		$result = new stdClass;
		$result->timestamp = waDateTime::date('d.m.Y H:i:s', $data['create_datetime']);
		//$result->external_id = $operation . '_'. wa()->getRouting()->getDomain().'_'.$data['id']; 
		//$result->external_id = $operation . '_'. $_SERVER['SERVER_NAME'].'_'.$data['id'];
		$result->external_id = $operation . '_'. $config->getOption('domain').'_'.$data['id'];
		$result->service = new stdClass;
		//$result->service->inn = $config->getOption('inn');

		$access_token = $config->getOption('access_token');
		$result->service->callback_url = (!empty( $access_token  ) ? 
		//( (waRequest::isHttps()) ? 'https://' : 'http://'  ) . wa()->getRouting()->getDomain().'/api.php?app=schetmash&method=callback&access_token='.$access_token.'&format=json'
		//( (waRequest::isHttps()) ? 'https://' : 'http://'  ) . $_SERVER['SERVER_NAME'] .'/api.php?app=schetmash&method=callback&access_token='.$access_token.'&format=json'
		$config->getOption('domain') .'/api.php?app=schetmash&method=callback&access_token='.$access_token.'&format=json'
		 : 	'' ) ;

		//$result->service->payment_address = $config->getOption('payment_address');
			
		$result->receipt = new stdClass;
		$result->receipt->attributes = new stdClass;
		//$result->receipt->attributes->sno = $config->getOption('sno');

		if(empty($data['contact']['email']) && empty($data['contact']['phone'])) {
			waLog::log('Не заполнены обязательные поля email или телефон', 'schetmash.log');
			 return false; 
		}
		if(!empty($data['contact']['email']) ) { $result->receipt->attributes->email = $data['contact']['email']; }
		if(!empty($data['contact']['phone']) ) { 
			$phone = str_replace(array(' ','-','(',')'), '', $data['contact']['phone']);
			$result->receipt->attributes->phone = $phone;
		}
		
			
		$result->receipt->payments = array();
		$result->receipt->items = array();
		$result->receipt->total = $this->formatFloat( $data['total']);
		
		$discount = 1; 
		if(isset($data['discount']) && $data['discount'] > 0) {
			$discount =  $data['total'] / ($data['total'] + $data['discount']);
		}		

		$typePayment = 1; // Временно 
		//foreach ($data['payments'] as $payment)
		//{
			$result->receipt->payments[] = array(
				'type' => $typePayment, 
				'sum' =>  $this->formatFloat( $data['total']) 
			);
		//}

		$total = 0; 

		if(isset($data['shipping']) && $data['shipping'] > 0 ) {
			
			$data['items'][] = array(
				'name' => ( (isset($data['params']['shipping_name']) && !empty($data['params']['shipping_name'])) ? $this->formatName(  $data['params']['shipping_name']) : 'Доставка'  ),
				'quantity' => 1,
				'tax_percent' => (isset($data['params']['shipping_tax_percent']) ? $data['params']['shipping_tax_percent'] : ''),  
				'price' => $data['shipping'], 
				'sum' => $data['shipping'], 
				'total_discount' => 0,
				'typeSchetmash' => 4
			);		
		}

		$countItem = count($data['items']);		

		foreach ($data['items'] as $i => $item)
		{
			$countItem--; 

			if(!isset($item['tax_percent']) || empty($item['tax_percent'])) { 
				$tax = 'none';  
			} else {
				switch((int)$item['tax_percent']) {
					case 20 : $tax = 'vat20'; break;
					case 18 : $tax = 'vat18'; break;
					case 10 : $tax = 'vat10'; break;
					case 0 : $tax = 'vat0'; break;
					default : $tax = 'none'; 
				}
			}	

			$price = $this->formatFloat(  $item['price'] * $discount );
			$quantity = $this->formatFloat( $item['quantity'], 3);
			$sum =  $this->formatFloat( $price * $quantity );

			if($countItem === 0) {

				$sum = $this->formatFloat( $data['total'] - $total ); 
				$price = $this->formatFloat(  $sum  / $quantity );
				if((($sum * 100) % $quantity) !== 0 ){
					if($quantity > 1) {
						$quantity = $quantity - 1;
						$price = $this->formatFloat( $item['price'] * $discount );
						$sum = $this->formatFloat( $price * $quantity );
						$sum2 = $this->formatFloat( $data['total'] - $total - $sum );
					
						$result->receipt->items[] = array(
							'name' => $this->formatName( $item['name'].' (акция!)', 118 ), 
							'price' => $sum2,
							'sum' => $sum2,
							'quantity' => 1,
							'tax' => $tax, 
							'type' => (isset($item['typeSchetmash']) ? $item['typeSchetmash'] : 1), //Товар, услуга или ... 
						);

					}

				} 

			}

			$total = $total + $sum;				
			
			$result->receipt->items[] = array(
				'name' => $this->formatName( $item['name'] ),
				'price' => $price,
				'sum' =>  $sum,
				'quantity' =>  $quantity,
				'tax' => $tax,
				'type' =>  (isset($item['typeSchetmash']) ? $item['typeSchetmash'] : 1), //Товар, услуга или ... 
				//'mode' => 4 
			);
		}



        return $result;        
	}

	private function formatName($name, $count = 128){    
		$name = htmlspecialchars_decode($name);
		$name = strip_tags($name);	
		$name = preg_replace('|\s+|',' ', $name);
		$name = trim($name);
		$name = mb_substr ( $name, 0, $count, 'UTF-8');
		return $name; 
	}


	private function formatFloat( $int, $count = 2){
		$int = str_replace(',', '.', $int);
		return	round( (float)$int , $count);
	}


	private function requestAccessToken()
	{

		$config = wa('schetmash')->getConfig();

		$data = new stdClass;
		$data->login = $config->getOption('login');
		$data->password = $config->getOption('password');		

		if(empty($data->login) || empty($data->password) ) { 
			waLog::log('Логин или пароль не заполнены', 'schetmash.log'); 
			return false; 
		}

		$result = $this->send('token',  $data);	
		
		if ( is_object($result) && isset($result->token) && !empty($result->token) )
		{
			$settings = $config->getOption(null);
			$settings['token'] = $result->token;
			$config_file = $config->getConfigPath('config.php');
			waUtils::varExportToFile($settings, $config_file);

			return $result->token;
		} else {
			waLog::log('Не удалось получить токен', 'schetmash.log');
		}


		if ( is_object($result) && isset($result->code)  && $result->code == 1 ) { 
			waLog::log('Неверный логин или пароль', 'schetmash.log'); 
		}

		return false;
	}


	private function send($_path = '', $_data = null)    {

		//waLog::log(print_r($_data, 1), 'schetmash.log');
        
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_URL, static::SERVICE_URL.'/'.$_path);
        curl_setopt($curl, CURLOPT_PORT , static::SERVICE_PORT);         
        if(isset($_data)) { 
			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
			curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($_data));  
		  }  
        curl_setopt($curl, CURLOPT_HEADER, false);
//        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
//        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true); 
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);

        $out = curl_exec($curl); #Инициируем запрос к API и сохраняем ответ в переменную
        $code = curl_getinfo($curl, CURLINFO_HTTP_CODE); #Получим HTTP-код ответа сервера
        $err = curl_error($curl);
		curl_close($curl); #Завершаем сеанс cURL


        if (!$code) {  waLog::log('Сервер вернул ошибку! '. $err, 'schetmash.log'); return false;  }  		     
		if ((int)$code !== 200) { waLog::log('Сервер вернул ошибку! Код ошибки: '.$code, 'schetmash.log');  return false;      }
		
		//waLog::log(print_r($out,1), 'schetmash.log');
		  
        return json_decode( $out );		
	}
	

	private function printImmediately($order, $operation)
	{	
		$config = wa('schetmash')->getConfig();		
		$token = $config->getOption('token');
		$shopid = $config->getOption('shopid');

		if(empty($shopid) ) { 		 
			waLog::log('Нет shopid', 'schetmash.log');
			return false;
		}

		$url = $shopid . '/' . $operation . '?token=';

		if (empty($token ))	{
			$token = $this->requestAccessToken();
			if (!$token ) {	return false;	}
		}

		$checkQuery = $this->buildCheckQuery($order, $operation);
		if($checkQuery === false) { return false;  }

		$result = $this->send($url.$token, $checkQuery); 	

		if(!is_object($result) ) { return false;  }

		if (isset($result->code) && ($result->code  ==  2 || $result->code == 4) )	{		
			$token = $this->requestAccessToken();
			if (!$token)	{	return false;	}
			
			$result = $this->send($url.$token, $checkQuery);
			if(!is_object($result) ) { return false;  }	
		}


		if (isset($result->id)  )	{
			return $result; 
		} 
		

		return false;
	}


	public function getStatusCheck($uuid) {

		$report = array('mess' => '', 'status' => false ); 
		$config = wa('schetmash')->getConfig();		
		$token = $config->getOption('token');
		$shopid = $config->getOption('shopid');

		if(empty($shopid) ) { 
			waLog::log('Нет shopid', 'schetmash.log');
			return 'Нет shopid';
		}

		$url = $shopid . '/report/' . $uuid . '?token=';

		if (empty($token ))	{
			$token = $this->requestAccessToken();
			if (!$token ) {					 
				$report['mess'] = 'Не удалось получить токен';
				return $report;
			}
		}

		$result = $this->send($url.$token); 

		if(!is_object($result)  ) {
			$report['mess'] = 'Нет связи с сервером';
			 return $report; 
			 }

		if (isset($result->code) && ($result->code  ==  2 || $result->code == 4) )	{	
			$token = $this->requestAccessToken();
			if (!$token)	{			
				$report['mess'] =  'Не удалось получить токен';
				return $report;
			}

			$result = $this->send($url.$token);
			if(!is_object($result) ) { 
				$report['mess'] = 'Нет связи с сервером';
				return $report; 
			  }	
		}

		if (isset($result->id)  )	{			 
			return $this->updateCheck($result);
		} 

		return $report; 
	}



	

	public function addCheck($order_id, $operation, $update = false) {
	
		$order_id = (int)$order_id;
		$report = array('mess' => '', 'status' => false ); 

		wa('shop');
		$order = new shopOrderModel();  	
		$orderData = $order->getOrder($order_id);	
		if($orderData === false || empty($orderData)) {  
			waLog::log('Этот заказ не найден', 'schetmash.log'); 
			$report['mess'] = 'Этот заказ не найден';
			return $report; 
		}	
		
		if( array_key_exists('payment_plugin', $orderData['params']) && !empty($orderData['params']['payment_plugin'])  ) {		

			$config = wa('schetmash')->getConfig();
			$pay = array_search($orderData['params']['payment_plugin'], $config->getOption('payments') );
			if($pay === false) { 
				$report['mess'] = 'Этот способ оплаты не выбран для печати чеков';
				return $report;
			 }
		}

		$curDate = waDateTime::date('Y-m-d H:i:s');	
        $result = $this->printImmediately($orderData, $operation); 		
		if($result === false || !is_object($result)) { 
			//return false; 
			$result = new stdClass;
			$result->status = 'no_conn';	
		}

		$data = array();
		$data['status'] = substr( (string)$result->status, 0, 20); 
		if(isset($result->id) ) { $data['uuid'] =  $result->id;  } 			

		

		if(!$update) { 
			$data['order_id'] = $order_id;
			$data['data_create'] = $curDate; 
		}

		$data['sum'] =	$this->formatFloat( $orderData['total']); 
		$data['type'] = (string)$operation;
		$data['error'] = (!empty($result->error) ? json_encode($result->error) : '' ); 

		if(!$update) {
			$id = $this->insert($data);	
		} else {
			$id = $this->updateById($update, $data);
		}
		if($id) {
			$report = array('mess' => 'Чек добавлен', 'status' => true ); 
			return $report; 
		}
	}



	public function updateCheck($result) {	
		$report = array('mess' => 'Не удалось получить статус чека', 'status' => false ); 
		if(!is_object($result) || !isset($result->id) || !isset($result->status) || $result->status == 'accept' || $result->status == 'processing')   { return $report; } 		

		$data = array();
		$data['status'] = substr( (string)$result->status, 0, 20); 
		if(isset($result->timestamp) ) { $data['data_print_end'] =  waDateTime::date('Y-m-d H:i:s', $result->timestamp); }	
		if(!empty($result->error) ) { $data['error'] =  json_encode($result->error); } 
		if(!empty($result->payload) ) { $data['payload'] =  json_encode($result->payload); }		

		$upd = $this->updateByField(array('uuid' => $result->id ) , $data);
 
		if($upd) {
			 $report = array('mess' => 'Статус чека изменён', 'status' => true ); 
		 } else {
			 $report['mess'] = 'Не удалось обновить чек';
		 }

		return $report; 
	}




	public function deleteCheck($id) {
		$this->deleteById((int)$id);
	}



	public function getProcessingCheck(){

		$dt = new \DateTime();
		$dt->sub(new \DateInterval('P20D'));

		return $this->query("SELECT `uuid`,`id`,`type`,`order_id` FROM ".$this->table." WHERE `data_create` > '".$dt->format('Y-m-d H:i:s')."' AND (`status` = 'processing' OR `status` = 'accept' OR `status` = 'no_conn') ORDER BY RAND() LIMIT 1")->fetch();	
	}

	public function getList($offset = 0, $countPage = 30, $where = false) {	

		$whereStr = '';
		if($where){ 
			$whereStr = ' WHERE '.implode(' AND ', $where);
		}

		$list = $this->query("SELECT SQL_CALC_FOUND_ROWS * FROM ".$this->table.$whereStr." ORDER BY `data_create` DESC LIMIT ".(int)$offset.", ".(int)$countPage)->fetchAll();
		
		$count = $this->query("SELECT FOUND_ROWS()")->fetchField();	

		foreach($list as &$item){

			$item['link_params'] = '';
            
			if(!empty($item['payload']) ) { 
				$item['link_params'] = $this->ofd1($item['payload'],  $item['type']); 
				$this->parse($item['payload']); 				
			}
			if(!empty($item['error']) ) {  $this->parse($item['error'], false);  }

		}
		
		return array('list' => $list, 'count' => (int)$count); 		
	}

	public function getCount() {
		return $this->query("SELECT COUNT(*) FROM ".$this->table)->fetchField();
	}

	private function parse(&$json, $lang = true)
	{
		$str = '';
		$arr = json_decode($json, true, 2);
		if(is_array($arr) ) {
			foreach($arr as $k => $v) {
				if($lang) {
					$str .=  _w($k)  . ' - <strong>' . $v .'</strong><br />';
				} else {
					$str .=  $k  . ' - <strong>' . $v .'</strong><br />';
				}  
			}
			$json = htmlspecialchars( $str);
		}		
	}

	private function ofd1($payload, $type) {

		switch ($type) {
			case 'sell': $n = 1; break;
			case 'sell_refund': $n = 2; break;
			case 'buy': $n = 3; break;
			case 'buy_refund': $n = 4; break;			
			default: $n = '';	break;
		}

		$ob = json_decode($payload);
		$param = array();		
		$param['t'] = waDateTime::date('Ymd\THi', $ob->receipt_datetime);
		$param['s'] = $this->formatFloat($ob->total);
		$param['fn']= $ob->fn_number;
		$param['i'] = $ob->fiscal_document_number;
		$param['fp'] = $ob->fiscal_document_attribute;
		$param['n'] = $n; 

		return 'https://consumer.1-ofd.ru/v1?'.http_build_query($param);	
	}


	public function getLink($order_id, $type = 'sell'){

		$link = '';
		$row =  $this->query("SELECT `payload`,`type` FROM ".$this->table." WHERE `status` = 'success' AND `order_id` = ".(int)$order_id." AND `type` = '".$this->escape($type)."' LIMIT 1")->fetch();
		if(!empty($row['payload'])  && !empty($row['type'])) { 
			$link = $this->ofd1($row['payload'], $row['type']);
		}

		return $link; 
	}




}